﻿/*
  KeeModifiedBy Plugin
  Copyright (C) 2023 Dominik Reichl <dominik.reichl@t-online.de>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;

using KeePass.UI;

using KeePassLib;

namespace KeeModifiedBy
{
	public sealed class KmbColumnProvider : ColumnProvider
	{
		private const string KmbcUser = "Modified by User";
		private const string KmbcMachine = "Modified by Machine";

		private static readonly string[] g_vNames = new string[] {
			KmbcUser, KmbcMachine };
		public override string[] ColumnNames
		{
			get { return g_vNames; }
		}

		public override string GetCellData(string strColumnName, PwEntry pe)
		{
			if(pe == null) { Debug.Assert(false); return string.Empty; }

			string str;
			if(strColumnName == KmbcUser)
				str = pe.CustomData.Get(KeeModifiedByExt.KmbkUser);
			else if(strColumnName == KmbcMachine)
				str = pe.CustomData.Get(KeeModifiedByExt.KmbkMachine);
			else { Debug.Assert(false); str = null; }

			return (string.IsNullOrEmpty(str) ? "?" : str);
		}
	}
}
